Call subEnumerateDBBackups


Sub subEnumerateDBBackups
	Dim oApp        'As SQLDMO.Application
	Dim oServer     'As SQLDMO.SQLServer
	Dim oDatabase   'As SQLDMO.Database
	Dim oNames      'As SQLDMO.NameList
	Dim oName       'As Variant
	Dim Connection1 'As Variant
	Dim sMsgWindow	'As String

	Set oApp = CreateObject("SQLDMO.Application")
	Set oNames = oApp.ListAvailableSQLServers()

	on error resume next

	For Each oName In oNames
		Set oServer = CreateObject("SQLDmo.SqlServer")

		oServer.LoginSecure = True
		oServer.Connect oName
		if err.number <> 0 then
			strErrorMsg = strErrorMsg & "" & vbCRLF
			strErrorMsg = strErrorMsg & "trouble connecting to " & oName & vbCRLF
			strErrorMsg = strErrorMsg & "" & vbCRLF

			err.Clear
	    		call writefile("C:\sqlbackupinfo.txt",strErrorMsg)
			strErrorMsg = ""
		end if 
	    

			strDBBackupList = ""
			set objDBList = new clsServerBackupInfoList
				objdblist.SQLServer = oName
				strDBBackupList = strDBBackupList & objdblist.SQLServer & vbCRLF
				while not objDBList.EOF
					strDBBackupList = strDBBackupList & objDBList.Database & vbTab
					set objDBInfo = new clsDBBackupInfo
					objDBInfo.SQLServer = objdblist.SQLServer
					objDBInfo.Database	= objDBList.Database
					strDBBackupList = strDBBackupList & "Last Backup: " & objdbinfo.StartTime & " Result " & objdbinfo.Success & " " & objdbinfo.Message & " " & objdbinfo.Plan & vbCRLF
					set objDBInfo = nothing
					objDBList.MoveNext
				Wend
			call writefile("C:\sqlbackupinfo.txt",strDBBackupList)
			set objDBList = nothing
	Next

	oServer.DisConnect
	Set oServer = Nothing

	oApp.Quit
	Set oApp = Nothing 
End Sub

	
Sub WriteFile(byval strFileName, byval strOutput)
        Dim fso, File
        Set fso      = CreateObject("Scripting.FileSystemObject")
        Set wshShell = WScript.CreateObject("WScript.Shell" )
        If not fso.FileExists(strFileName) then
                Set  master = fso.CreateTextFile(strFileName)
        Else
                Set  master = fso.OpenTextFile(strFileName,8)
        End if
        master.WriteLine "Entry for " & Now() & vbCRLF
        master.WriteLine strOutPut
        master.close
End Sub


'****************************************************
'*
'*	CLASS clsDBBackupInfo
'*
'****************************************************
'*	The purpose of this class is to list the backups for a given database.
'*	The information can be retrieved via a text message using the GetBackupHist()
'*	method or using the individual elements using the gets.
'* 
'*  LETS
'*	SQLServer	- Server whose maintenance plans you want to query
'*	Database	- Database we want to look up last the last backup for
'*
'*  GETS
'*	SQLServer	- Server Name
'*	Database	- Database Name
'*	Plan		- Plan name containing the backup
'*	Success		- was the last backup a success
'*	EndTime		- when the last backup ended
'*	StartTime	- when the last backup started
'*	Duration	- the length of time the last backup took
'*	Message		- message for the last backup usually the location of the backup file
'*
'*	Public Functions
'*	GetBackupHist() -	Returns a string containing the backup information and populates the GETS.
'*****
'*
'*		Sample for clsDBBackupInfo
'*
'*****
'
'	set objDBInfo = new clsDBBackupInfo
'	objDBInfo.SQLServer = "QASQL"
'	objDBInfo.UserID = "sa"
'	objDBInfo.Password = "05sysa30"
'	objDBInfo.Database	= "PL_Inventory"
'	msgbox objDBInfo.GetBackupHist
'	strDBMsg = ""
'	strDBMsg = strDBMsg & "Database " & objdbinfo.Database & vbCRLF
'	strDBMsg = strDBMsg & "Start Time " & objdbinfo.StartTime & vbCRLF
'	strDBMsg = strDBMsg & "EndTime " & objdbinfo.EndTime & vbCRLF
'	strDBMsg = strDBMsg & "Duration " & objdbinfo.Duration & vbCRLF
'	strDBMsg = strDBMsg & "Plan " & objdbinfo.Plan & vbCRLF
'	strDBMsg = strDBMsg & "Success " & objdbinfo.Success & vbCRLF
'	strDBMsg = strDBMsg & "Message " & objdbinfo.Message & vbCRLF
'	msgbox strDBMsg
'
'	msgbox objDBInfo.GetBackupHist
'
'	set objDBInfo = nothing
'********************************************************
class clsDBBackupInfo
	private strSQLServer
	private strDataBase
	private objCon
	private SQL2
	private RS1
	private str
	private fd
	private ConnectionString
	private strPlan
	private boolSuccess
	private dtEndTime
	private dtStartTime
	private dtDuration
	private strMessage
	private boolSecurity
	private strUserID
	private strPassword
	
	Private Sub Class_Initialize()
		boolSecurity = TRUE
	End Sub
	
	Private Sub Class_Terminate()
		Call closeConnection
	End Sub
	
	Public Property Let SQLServer ( byVal tmpSQLServer )
		strSQLServer = tmpSQLServer
		if len(strSQLServer) > 0 and len(strDatabase) > 0 then 
			Dim SQL2
			Dim RS1
			Dim str
			Dim fd

			SQL2 = SQL2 & "SELECT TOP 1 * FROM sysdbmaintplan_history " 
			SQL2 = SQL2 & "WHERE (activity LIKE " & "'" & "backup database" & "'" & ") AND (database_name = " & "'" & strDatabase & "') "	
			SQL2 = SQL2 & "ORDER BY end_time Desc"

			Call openConnection()

			Set RS1 = objCon.Execute(SQL2)
		
			if not RS1.eof then
				for each fd	in RS1.Fields
					str	= str	&	fd.name & "     " & fd.value & vbCRLF
				next
				strPlan			= RS1("Plan_name")
				boolSuccess		= RS1("Succeeded")
				dtStartTime		= RS1("Start_Time")	
				dtEndTime		= RS1("End_time")
				dtDuration		= RS1("Duration")
				strMessage		= RS1("Message")
			else 
				strPlan			= ""
				boolSuccess		= ""
				dtStartTime		= ""
				dtEndTime		= ""
				dtDuration		= ""
				strMessage		= ""
			end if
			Set RS1 = Nothing
		end if
	End Property
	
	Public Property Let Database ( byVal tmpDatabase )
		strDatabase = tmpDatabase
			if len(strSQLServer) > 0 and len(strDatabase) > 0 then 
				Dim SQL2
				Dim RS1
				Dim str
				Dim fd

				SQL2 = SQL2 & "SELECT TOP 1 * FROM sysdbmaintplan_history " 
				SQL2 = SQL2 & "WHERE (activity LIKE " & "'" & "backup database" & "'" & ") AND (database_name = " & "'" & strDatabase & "') "	
				SQL2 = SQL2 & "ORDER BY end_time Desc"

				Call openConnection()

				Set RS1 = objCon.Execute(SQL2)
			
				if not RS1.eof then
					for each fd	in RS1.Fields
						str	= str	&	fd.name & "     " & fd.value & vbCRLF
					next
					strPlan			= RS1("Plan_name")
					boolSuccess		= RS1("Succeeded")
					dtStartTime		= RS1("Start_Time")	
					dtEndTime		= RS1("End_time")
					dtDuration		= RS1("Duration")
					strMessage		= RS1("Message")
				else 
					strPlan			= ""
					boolSuccess		= ""
					dtStartTime		= ""
					dtEndTime		= ""
					dtDuration		= ""
					strMessage		= ""
				end if
				Set RS1 = Nothing
			end if
	End Property
	
	Public Property Let Security ( byVal tmpSecurity )
		boolSecurity = tmpSecurity
	End Property
	
	Public Property Let UserID ( byVal tmpUserID )
		strUserID = tmpUserID
		boolSecurity = FALSE
	End Property
	
	Public Property Let Password ( byVal tmpPassword )
		strPassword = tmpPassword
		boolSecurity = FALSE
	End Property
	
	Public Property Get SQLServer
		SQLServer = strSQLServer
	End Property

	Public Property Get Database
		Database = strDatabase
	End Property

	Public Property Get Plan
		Plan = strPlan
	End Property

	Public Property Get Success
		Success = boolSuccess
	End Property

	Public Property Get EndTime
		EndTime = dtEndTime
	End Property

	Public Property Get StartTime
		StartTime = dtStartTime
	End Property

	Public Property Get Duration
		Duration = dtDuration
	End Property

	Public Property Get Message
		Message = strMessage
	End Property


	Private Sub openConnection()	
		
		Set objCon = WScript.CreateObject("ADODB.Connection") 		
		
		ConnectionString	= 	"Provider=sqloledb;"
		ConnectionString	= 	ConnectionString	&	"Data Source=" & strSQLServer & ";" 
		ConnectionString	= 	ConnectionString	&	 "Initial Catalog=MSDB;"
		if boolSecurity = TRUE then
			ConnectionString	= 	ConnectionString	&	 "Integrated Security=SSPI;"
		else
			ConnectionString	= 	ConnectionString	&	 "User Id="		& strUserID		& ";" 
			ConnectionString	= 	ConnectionString	&	 "Password="	& strPassword	& ";"
		end if
 
		
		objCon.Open ConnectionString
		
	End Sub

	Private Sub closeConnection()	
		objCon.Close
	End Sub

	Public Function GetBackupHist()
		Dim SQL2
		Dim RS1
		Dim str
		Dim fd

		SQL2 = SQL2 & "SELECT TOP 1 * FROM sysdbmaintplan_history " 
		SQL2 = SQL2 & "WHERE (activity LIKE " & "'" & "backup database" & "'" & ") AND (database_name = " & "'" & strDatabase & "') "	
		SQL2 = SQL2 & "ORDER BY end_time Desc"

		Call openConnection()

		Set RS1 = objCon.Execute(SQL2)
	
		if not RS1.eof then
			for each fd	in RS1.Fields
				str	= str	&	fd.name & "     " & fd.value & vbCRLF
			next
			strPlan			= RS1("Plan_name")
			boolSuccess		= RS1("Succeeded")
			dtStartTime		= RS1("Start_Time")	
			dtEndTime		= RS1("End_time")
			dtDuration		= RS1("Duration")
			strMessage		= RS1("Message")
		else 
			str = "No Backups for " & strDatabase & " on " & strSQLServer
			strPlan			= ""
			boolSuccess		= ""
			dtStartTime		= ""
			dtEndTime		= ""
			dtDuration		= ""
			strMessage		= ""
		end if
		 
		GetBackupHist = str
		Set RS1 = Nothing
		
	End Function

End Class
'****************************************************
'*
'*	END CLASS clsDBBackupInfo
'*
'****************************************************
'****************************************************
'*
'*	CLASS clsServerBackupInfo
'*
'
'***** Sample for clsServerBackupInfo
'set objServerInfo = new clsServerBackupInfo
'objServerInfo.SQLServer = "szabob"
'msgbox objServerInfo.GetBackedUpDBs
'set objServerInfo = nothing
'*****
'
'****************************************************
Class clsServerBackupInfo

	private strSQLServer
	private strDataBase
	private objCon
	private SQL2
	private RS1
	private str
	private fd
	private ConnectionString
	
	Private Sub Class_Initialize()
	End Sub
	
	Private Sub Class_Terminate()
		Call closeConnection
	End Sub
	
	Public Property Let SQLServer ( byVal tmpSQLServer )
		strSQLServer = tmpSQLServer
		if len(strSQLServer) > 0 then 
			Call OpenConnection
		end if
	End Property
	
	Public Property Let Database ( byVal tmpDatabase )
		strDatabase = tmpDatabase
	End Property
	
	Public Property Get SQLServer
		SQLServer = strSQLServer
	End Property

	Public Property Get Database
		Database = strDatabase
	End Property

	Private Sub openConnection()	
		
		Set objCon = WScript.CreateObject("ADODB.Connection") 		
		
		ConnectionString	= 	"Provider=sqloledb;"
		ConnectionString	= 	ConnectionString	&	"Data Source=" & strSQLServer & ";" 
		ConnectionString	= 	ConnectionString	&	 "Initial Catalog=MSDB;"
		ConnectionString	= 	ConnectionString	&	 "Integrated Security=SSPI;"
		
		objCon.Open ConnectionString
		
	End Sub

	Private Sub closeConnection()	
		objCon.Close
	End Sub

	Public Function GetBackedUpDBs()
		Dim SQL2
		Dim RS1
		Dim str
		Dim fd

		SQL2 = SQL2 & "SELECT distinct database_name FROM sysdbmaintplan_history " 
		SQL2 = SQL2 & "WHERE (activity LIKE " & "'" & "backup database" & "'" & ")"
'		SQL2 = SQL2 & "ORDER BY end_time Desc"

		Call openConnection()

		Set RS1 = objCon.Execute(SQL2)
	
		if not RS1.eof then
			str = "Backed Up Databases"
			while not RS1.eof
				for each fd	in RS1.Fields
					str	= str	& fd.value & vbCRLF
				next
				RS1.MoveNext
			Wend
			RS1.MoveFirst
		else 
			str = "No Backups for " & strDatabase & " on " & strSQLServer
		end if
		 
		GetBackedUpDBs = str
		Set RS1 = Nothing
		
	End Function

End Class
'****************************************************
'*
'*	END CLASS clsServerBackupInfo
'*
'****************************************************


'****************************************************
'*
'*	CLASS clsServerBackupInfoList
'*
'set objDBList = new clsServerBackupInfoList
'set objDBInfo = new clsDBBackupInfo
'	objDBInfo.SQLServer = "szabob"
'	objDBList.SQLServer = "szabob"
'
'	while not objDBList.EOF
'		objDBInfo.Database	= objDBList.Database
'		msgbox objDBInfo.GetBackupHist
'		objDBList.MoveNext
'	Wend
'
'set objDBList = nothing
'set objDBInfo = nothing
'****************************************************
Class clsServerBackupInfoList

	private strSQLServer
	private strDataBase
	private objCon
	private SQL2
	private RS1
	private str
	private fd
	private ConnectionString
	private boolEOF
	
	Private Sub Class_Initialize()
		boolEOF = true
	End Sub
	
	Private Sub Class_Terminate()
		if RS1.State <> 0 then
			RS1.close
			Set RS1 = Nothing
		end if
		Call closeConnection
	End Sub
	
	Public Property Let SQLServer ( byVal tmpSQLServer )
		strSQLServer = tmpSQLServer
		if len(strSQLServer) > 0 then 
			Set objCon = WScript.CreateObject("ADODB.Connection") 		
			
			ConnectionString	= 	"Provider=sqloledb;"
			ConnectionString	= 	ConnectionString	&	"Data Source=" & strSQLServer & ";" 
			ConnectionString	= 	ConnectionString	&	 "Initial Catalog=MSDB;"
			ConnectionString	= 	ConnectionString	&	 "Integrated Security=SSPI;"
			
			objCon.Open ConnectionString
			SQL2 = SQL2 & "SELECT distinct database_name FROM sysdbmaintplan_history " 
			SQL2 = SQL2 & "WHERE (activity LIKE " & "'" & "backup database" & "'" & ")"
			
			Set RS1 = objCon.Execute(SQL2)

			if not RS1.eof then
				strDatabase = RS1("database_name")
				boolEOF = False
			else 
'				strDatabase = RS1("database_name")
				boolEOF = True
			end if
		end if
	End Property
	
	Public Property Let Database ( byVal tmpDatabase )
		strDatabase = tmpDatabase
	End Property
	
	Public Property Get SQLServer
		SQLServer = strSQLServer
	End Property

	Public Property Get Database
		Database = strDatabase
	End Property

	Public Property Get EOF
		EOF = boolEOF
	End Property

	Public Sub MoveNext
			RS1.MoveNext
		if not RS1.EOF then
			strDatabase = RS1("Database_name")
			boolEOF = false
		else 
			boolEOF = True
		end if
	end sub

	Private Sub closeConnection()	
		objCon.Close
	End Sub

End Class
'****************************************************
'*
'*	END CLASS clsServerBackupInfoList
'*
'****************************************************
